//
// $Id: Config.h.in,v 1.21 2005/07/12 19:15:36 will_mason Exp $
//
// vi: set ft=objc:

/*
 * ObjectiveLib - a library of containers and algorithms for Objective-C
 *
 * Copyright (c) 2004
 * Will Mason
 *
 * Portions:
 *
 * Copyright (c) 1994
 * Hewlett-Packard Company
 *
 * Copyright (c) 1996,1997
 * Silicon Graphics Computer Systems, Inc.
 *
 * Copyright (c) 1997
 * Moscow Center for SPARC Technology
 *
 * Copyright (c) 1999 
 * Boris Fomitchev
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You may contact the author at will_mason@users.sourceforge.net.
 */

#if !defined(CONFIG_OL_GUARD)
#define CONFIG_OL_GUARD

/**
 * @defgroup Misc Types & Configuration
 *
 * Types and defined values for general use.
 */

/**
 * @defgroup Configuration
 *
 * Capabilities of the system that were determined or set when @b ObjectiveLib was
 * built. The following values are set according to the capabilities present in the
 * system on which @b ObjectiveLib was built. Only those capabilites that are actually
 * present appear in this documentation. A complete list of definable configuration
 * settings follows so that known capabilities may be queried at compile time.
 *
 * - OL_HAVE_INTTYPES_H
 * - OL_HAVE_INET6_SOCKETS
 * - OL_HAVE_UNIX_SOCKETS
 * - OL_HAVE_SO_REUSEPORT
 * - OL_MAJOR_VERSION
 * - OL_MINOR_VERSION
 *
 * @ingroup Misc
 */

/**
 * Non-zero if the file @c inttypes.h is present on the system. Indicates that the file
 * @c inttypes.h can be included. This setting is just a safety measure to make sure that
 * basic sanity rules.
 *
 * @ingroup Configuration
 */
#undef OL_HAVE_INTTYPES_H

/**
 * Non-zero if IPv6 sockets are present. If this is undefined then non of the IPv6
 * socket addressing capabilities will be present.
 *
 * @ingroup Configuration
 */
#undef OL_HAVE_INET6_SOCKETS

/**
 * Non-zero if Unix domain sockets are present. If this is undefined then Unix domain
 * sockets and addresses will be unavailable.
 *
 * @ingroup Configuration
 */
#undef OL_HAVE_UNIX_SOCKETS

/**
 * Non-zero if the socket option SO_REUSEPORT is present.
 *
 * @sa OLSocket::hasReusePortSupport, OLSocket::reusePort, OLSocket::setReusePort:
 *
 * @ingroup Configuration
 */
#undef OL_HAVE_SO_REUSEPORT

/**
 * The major version number of the current @b ObjectiveLib system.
 *
 * @sa OL_MINOR_VERSION
 *
 * @ingroup Configuration
 */
#undef OL_MAJOR_VERSION

/**
 * The minor version number of the current @b ObjectiveLib system.
 *
 * @sa OL_MAJOR_VERSION
 *
 * @ingroup Configuration
 */
#undef OL_MINOR_VERSION

#endif
